# Copyright (c) Microsoft Corporation.
# Licensed under the MIT license.

# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class BoostExpression(Model):
    """An expression that modifies the ranking score for item search results
    satisfying a condition.

    :param condition: The condition that items must satisfy to be boosted.
    :type condition: ~microsoft.bing.commerce.search.models.ConditionBase
    :param boost: The value to add to the ranking score. The range is
     -10,000,000 to 10,000,000.
    :type boost: float
    """

    _attribute_map = {
        'condition': {'key': 'condition', 'type': 'ConditionBase'},
        'boost': {'key': 'boost', 'type': 'float'},
    }

    def __init__(self, *, condition=None, boost: float=None, **kwargs) -> None:
        super(BoostExpression, self).__init__(**kwargs)
        self.condition = condition
        self.boost = boost
